﻿
using HeuristicLab.Problems.RoutePlanning.Osm;
namespace HeuristicLab.Problems.RoutePlanning.Graph {
  public class TravelTimeCostCalculator : ICostCalculator {
    #region CostCalculator Members

    public float Costs(Edge<Vertex> edge) {
      double distance = Utils.Distance(edge.Source.Logitude, edge.Source.Latitude,
                                       edge.Target.Logitude, edge.Target.Latitude);
      //double distance = Utils.LocationDistance(source.Node.Point, target.Node.Point);
      int speed = edge.GetMaxSpeed();
      double weight = (distance / speed) * 3.6;
      //double weight = (distance / speed);
      return (float)weight;
    }

    public float EstimatedCosts(Vertex source, Vertex destination) {
      double distance = Utils.Distance(source.Logitude, source.Latitude,
                                       destination.Logitude, destination.Latitude);
      //double distance = Utils.LocationDistance(source.Node.Point, target.Node.Point);
      int speed = 130;
      double costs = (distance / speed) * 3.6;
      //double costs = (distance / speed);
      return (float)costs;
    }

    #endregion
  }
}
